commit 2f51bcca74ed54f92ecb671da254a570bb324a1f
Author: freddy77 <freddy77>
Date:   Mon Jul 14 15:12:42 2008 +0000

    small improves for SQLWCHAR support

diff --git a/ChangeLog b/ChangeLog
index 9167726..183fb5c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jul 14 17:09:56 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* TODO.freddy src/odbc/odbc.c src/odbc/odbc_util.c:
+	- small improves for SQLWCHAR support
+
 Mon Jul 14 09:49:12 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* src/odbc/odbc_util.c added two symbols to a switch
 
@@ -434,4 +438,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2556 2008/07/14 14:06:14 jklowden Exp $
+$Id: ChangeLog,v 1.2557 2008/07/14 15:12:42 freddy77 Exp $
diff --git a/TODO.freddy b/TODO.freddy
index 521a55a..663dd53 100644
--- a/TODO.freddy
+++ b/TODO.freddy
@@ -43,6 +43,16 @@ Done handling
 Callback when state goes to IDLE
 Free unused cursors and dynamic and/or reuse them
 
+ODBC SQL_C_CHAR with wide
+-------------------------
+Check iso8859-1 for single ??
+test to review
+- data.c (char -> sql_c_char)
+- genparams.c
+- getdata.c ??
+- putdata.c ??
+- wchar.c
+
 Other
 -----
 Implement some sort of fast write to network writing directly to 
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 75645f2..bafb504 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.484 2008/07/04 21:08:39 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.485 2008/07/14 15:12:42 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -1232,7 +1232,7 @@ _SQLBindParameter(SQLHSTMT hstmt, SQLUSMALLINT ipar, SQLSMALLINT fParamType, SQL
 	stmt->need_reprepare = 1;
 
 	/* TODO other types ?? handle SQL_C_DEFAULT */
-	if (drec->sql_desc_type == SQL_C_CHAR || drec->sql_desc_type == SQL_C_BINARY)
+	if (drec->sql_desc_type == SQL_C_CHAR || drec->sql_desc_type == SQL_C_WCHAR || drec->sql_desc_type == SQL_C_BINARY)
 		drec->sql_desc_octet_length = cbValueMax;
 	drec->sql_desc_indicator_ptr = pcbValue;
 	drec->sql_desc_octet_length_ptr = pcbValue;
@@ -1573,6 +1573,7 @@ SQLBindCol(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	/* check conversion type */
 	switch (fCType) {
 	case SQL_C_CHAR:
+	case SQL_C_WCHAR:
 	case SQL_C_BINARY:
 	case SQL_C_DEFAULT:
 		/* check max buffer length */
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 2b87e1b..ddebbe1 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -38,7 +38,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.97 2008/07/14 14:06:15 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.98 2008/07/14 15:12:42 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -537,7 +537,13 @@ odbc_sql_to_displaysize(int sqltype, TDSCOLUMN *col)
 	case SQL_CHAR:
 	case SQL_VARCHAR:
 	case SQL_LONGVARCHAR:
-		size = col->column_size;
+		size = col->on_server.column_size;
+		break;
+	/* FIXME sure ?? *2 or not ?? */
+	case SQL_WCHAR:
+	case SQL_WVARCHAR:
+	case SQL_WLONGVARCHAR:
+		size = col->on_server.column_size / 2;
 		break;
 	case SQL_BINARY:
 	case SQL_VARBINARY:
@@ -618,6 +624,12 @@ odbc_sql_to_c_type_default(int sql_type)
 	case SQL_CHAR:
 	case SQL_VARCHAR:
 	case SQL_LONGVARCHAR:
+	/* these types map to SQL_C_CHAR for compatibility with old applications */
+#ifdef SQL_C_WCHAR
+	case SQL_WCHAR:
+	case SQL_WVARCHAR:
+	case SQL_WLONGVARCHAR:
+#endif
 		return SQL_C_CHAR;
 		/* for compatibility numeric are converted to CHAR, not to structure */
 	case SQL_DECIMAL:
@@ -807,7 +819,8 @@ odbc_get_param_len(const struct _drecord *drec_axd, const struct _drecord *drec_
 		len = 0;
 		/* TODO add XML if defined */
 		/* FIXME, other types available */
-		if (drec_axd->sql_desc_concise_type == SQL_C_CHAR || drec_axd->sql_desc_concise_type == SQL_C_BINARY) {
+		if (drec_axd->sql_desc_concise_type == SQL_C_CHAR || drec_axd->sql_desc_concise_type == SQL_C_WCHAR
+		    || drec_axd->sql_desc_concise_type == SQL_C_BINARY) {
 			len = SQL_NTS;
 		} else {
 			int type = drec_axd->sql_desc_concise_type;
@@ -1055,6 +1068,7 @@ odbc_get_octet_len(int c_type, const struct _drecord *drec)
 	/* this shit is mine -- freddy77 */
 	switch (c_type) {
 	case SQL_C_CHAR:
+	case SQL_C_WCHAR:
 	case SQL_C_BINARY:
 		len = drec->sql_desc_octet_length;
 		break;

